#ifndef COLOR
#define COLOR

#include <string>

enum class ColorValue;

class Color {
public:
    Color();
    Color(ColorValue cv);
    static Color from_fen(std::string);

    Color inverse() const;
    std::string to_fen() const;

	bool operator<(const Color& rhs) const;
    bool operator==(const Color& rhs) const;
    bool operator!=(const Color& rhs) const;
private:
    ColorValue value;
};

extern const Color NOT_A_COLOR, BLACK, WHITE;

#endif
