#ifndef SEARCH
#define SEARCH

#include <utility>

#include "Board.hpp"
#include "Move.hpp"
#include "Evaluation.hpp"
#include "Hash.hpp"
#include "History.hpp"

namespace Search {
	Move best_move(Board&, UNumber);

	class Manager {
	public:
		static void reset();

		static UNumber depth;
        static UNumber movetime;
        static UNumber nodes;
		static Board& board;
		static Hash::Table& table;

		static void start();
		static void stop();
		static void clear();
		static void join_all();

		static bool stoped;
		static Move best_move;
		static UNumber current_depth;
        static Hash::Table last_positions;
        static History::Table history;
	private:

		static void inc_search();
	};
}

#endif
